# dg239
from math import sqrt, ceil

"""Presents the user with a text adventure to navigate via user input."""


###################
###  FUNCTIONS  ###
###################

def test_ans(dec: str, choice: str, lna: int) -> str:
    """Ask question and test for legit answer."""
    if lna == 3:
        if dec == "A" or dec == "B" or dec == "C" or \
                dec == "a" or dec == "b" or dec == "c":
            return dec.upper()
        else:
            print("\nPlease only enter a SINGLE LETTER: A, B, or C.\n"
                  "Refer to the game's instructional first paragraph. ;)\n"
                  "The power of Tyrell compels you into selecting A...")
            return "A"
    elif lna == 2:
        if dec == "A" or dec == "B" or \
                dec == "a" or dec == "b":
            return dec.upper()
        else:
            print("\nPlease only enter a SINGLE LETTER: A or B.\n"
                  "Refer to the game's instructional first paragraph. ;)\n"
                  "The power of Tyrell compels you into selecting A...\n")
            return "A"
    else:
        print("Not sure how you got here! :D)")
        return ""


def print_response3(dec: str, a: str, b: str, c: str):
    """Print response to 3-optioned user input."""
    if dec == "A":
        print(a)
    elif dec == "B":
        print(b)
    elif dec == "C":
        print(c)


def print_response2(dec: str, a: str, b: str):
    """Print response to 2-optioned user input."""
    if dec == "A":
        print(a)
    elif dec == "B":
        print(b)


def check_float(potential_float) -> bool:
    """Try to convert argument into a float."""
    try:
        float(potential_float)
        return True
    except ValueError:
        return False



####################
###  BLOCK TEXT  ###
####################


intro_text = """
 The following is a text-adventure game where you get to enter your own choices
via input prompt.  When asked for input, you may simply enter the capital letter
you see next to the word or phrase you want to select.  No need to enter the
full word or phrase.  For ex. to choose (A) [Door], when prompted, you would
simply type:  A  (Got it?)  Typing anything else will result in the answer A,
or in the case of a number, 5, being automatically chosen for you.  Have fun!!!

 You're Rick Deckard, as-yet-unfamous Blade Runner.  It is early 2019. Your
memorable deadly scrape with the rogue band of Nexus-6 replicants, not to
mention your confusing, star-crossed tryst with the sensually aloof Rachael is
still months off.  You're in your office, a week before your planned exit from
the force, feet on your desk, when there's a knock at the door.  Outside, it's
raining.
"""

all_path_text = """
 He lays the folder in front of you and opens it, revealing a classified report
from one of the colony municipal divisions.  "Looks like there might've been an
interesting type of riot," says Bryant.  "Yeah, how's that?"  "From a Nexus-6
generation labor block, a handful went went berserk and took two guards hostage,
killed an additional 3."  You lift a pack of smokes from your trench coat and
peer inside, keeping an ear to Bryant.  You offer Bryant a cigarette.  "Don't
mind if I do," he says, greedily.
"""

all_path_text2 = """
 "Interesting thing is what the Nexus-6s said to the guards before the
authorities regained control."  "What's that?" you ask.  Bryant takes a drag,
expelling a trail of smoke into the dim office light.  "Nexus-6s kept talking
about having 'souls', and would come to account for them, sooner or later, on
Earth.  Weirder still, they said they were coming for the "Decoder", whoever he
is.  Some fella who can apparently give the square root of any number to three
decimal places."  "Wait," you say, "I've had that ability all my life."  "No
way," growls Bryant.  You look at him, dead on.  "Go ahead, give me a number,"
you say.
"""

all_path_text3 = """
 Bryant looks at you like you had 3 heads.  "I can't believe it.  They're coming
for YOU, Deck.  No idea how long we've got to prepare.  Wife is never going to
believe this one.  Speaking of which, her sister and sister’s husband are
bringing my nephew to stay this weekend.  What do you think of this riddle I'm
gonna dump on young Jack:  What's black, white, and red all over?"  You groan,
audibly.  You ask, "This really worth our time, Bryant?"
"""

all_path_text4 = """
 Outside, the rain continues to drum down in the sordid dark, upon the bleak
wasteland and cyber paradise that Los Angeles has become.  You watch as Bryant
closes the manilla folder and sways out with his jowly turgidness from your
office.  Hell.  Retirement was so close.  Only a month.  Why in God's name would
some rogue Nexus-6 units have you on their radar from off-world?  And souls?
Christ.  Replicants wouldn't know a soul from Jesus himself.  You rub your chin
and look out the narrow slit passing for a window to the outside.  Eventually,
you would have to get yourself over to Tyrell Corporation.  Field them a few
probably too-venturous questions.  Whatever the case...  it was time for a
drink.
"""

outro_text = """
 We hope you've enjoyed playing 'Bladerunner Prequel Text Adventure'.  Why don't
you try another round, this time making different choices and seeing what other
responses come your way as a result.  Enjoy your day, Deckard, and good luck!!!

"All these memories... will be lost in time, like tears in rain."
"""


################################
###  PURE TEXT CONSEQUENCES  ###
################################


###  CONSEQUENCES LEVEL 1  ###
cons1a = """
 You reach for your gun and shout, "Whoever's on the other side of that door is
gonna get blasted, if you're a big enough fool to enter!"  A gruff voice retorts
from the other side:  "Deckard, you wild mother scratcher, put that thing away
before I toss you another stint of unpaid leave."  Captain Bryant.  He
enters.
"""
cons1b = """
 You ask, guardedly, "Who is it?"  A gruff voice answers.  "Bryant!"  "All
 right, come on in."  You holster your pistol.  Bryant enters.  "Got something
interesting here from off-world."
"""
cons1c = """
 You dive under the desk, your battle-hardened instincts kicking in just in the
nick of time.  "Make your move, pal!" you shout.  "Deckard, you crazy bastard,"
Captain Bryant says, entering the room.  "Get up from the floor and holster that
piece."
"""

###  CONSEQUENCES LEVEL 2  ###
cons2aa = """
 You tell him to get lost and he sweeps up to your desk as though you hadn't
spoken, brandishing a manilla folder.  "Got something interesting here from
off-world."
"""
cons2ab = """
 You don't push Bryant's buttons any further and he approaches your desk holding
a manilla envelope.  "Got something interesting here from off-world."
"""

###  CONSEQUENCES LEVEL 3  ###
cons3a = """
 "Nah, you fool, it's a newspaper.  Is a Zebra READ all over?" Bryant chides.
"Now I want you to report tomorrow toot-effin-sweet to special forces training.
No idea what we're in for with these Rep-6s.  I want you ready, Deck."
"""
cons3b = """
 "Yeah, that's right.  A Newspaper.  READ... all over.  Smart man, Deck," Bryant
grunts.  "Now I want you to report tomorrow toot-effin-sweet to special forces
training.  No idea what we're in for with these Rep-6s.  I want you ready."
"""
cons3c = """
 "Nah, you fool, it's a newspaper.  Is a Dalmation READ all over?" Bryant
chides.  "Now I want you to report tomorrow toot-effin-sweet to special forces
training.  No idea what we're in for with these Rep-6s.  I want you ready,
Deck."
"""

#########################
###  CODE TO EXECUTE  ###
#########################

if __name__ == "__main__":
    pass
else:
    print("This script not to be run outside itself!")
    y = input("\nPress Y to run anyway, any other key to reject and close: \n")
    if y == "Y" or y == "y":
        pass
    else:
        exit()

# CONVERGENT STORY PATH CHAPTER 1
print(intro_text)

choice1a = str("Do you:  (A) [Reach for your gun] / (B) [Ask who it is] / "
               "(C) [Dive under the desk]? ")
dec1 = test_ans((input(choice1a)), choice1a, 3)
print_response3(dec1, cons1a, cons1b, cons1c)

if dec1 == "A":
    choice2a = str("Do you:  (A) [Tell him to get lost] / "
                   "(B) [Keep your trap shut]? ")
    dec2a = test_ans((input(choice2a)), choice2a, 2)
    print_response2(dec2a, cons2aa, cons2ab)
elif dec1 == "B":
    choice2b = "\n"
elif dec1 == "C":
    choice2c = str("Do you:  (A) [Tell him to get lost] / "
                   "(B) [Keep your trap shut]? ")
    dec2a = test_ans((input(choice2c)), choice2c, 2)
    print_response2(dec2a, cons2aa, cons2ab)
else:
    print("Not sure how you got here, Deckard! :P")

# CONVERGENT STORY PATH CHAPTER 2
all_path_text = all_path_text.strip('\n')
print(all_path_text)

smokes_left = input("\nHow many smokes do you have left? ")
if smokes_left.isdigit() is True:
    smokes_left = abs(int(smokes_left))
else:
    print("You should've entered a whole number - picking 5 for you...")
    smokes_left = 5
bryant_takes = input("How many of your smokes does Bryant take? ")
if bryant_takes.isdigit() is True:
    bryant_takes = abs(int(bryant_takes))
else:
    print("You should've entered a whole number - picking 5 for you...")
    bryant_takes = 5
smokes_diff = smokes_left - bryant_takes

greedy = """
You shout, "Listen, you greedy freak.  I don't care what your rank is; you don't
take all of a man's smokes when offered.  Bryant brushes you off and continues.
"""
tolerable = """
You grumble as Bryant slides one into his mouth and pockets the other {}.  He
points back to the report."
"""
if smokes_diff < 0:
    p = "\nHow does Bryant take {} if you've only got {} left, Deckard???"
    print(p.format(bryant_takes, smokes_left))
    print("Bryant can't take more smokes than you've got!!!")
    print("You broke the universe with negative smokes - adventure over!\n")
    quit()
elif smokes_diff == 0:
    print(greedy)
elif bryant_takes > 1:
    print(tolerable.format(bryant_takes - 1))
elif bryant_takes == 1:
    print("\nYou light the cig for Bryant and he continues.\n")

# CONVERGENT STORY PATH CHAPTER 3
all_path_text2 = all_path_text2.strip('\n')
print(all_path_text2)

too_easy = """
"Come on, that's too easy.  Square root of {} is {}.  Now give me a challenge.
Give me some big number with a decimal."
"""

ok_but_bigger = """
"No problem.  Square root of {} is {}.  Now give me something bigger - a lot 
bigger with a decimal."
"""

ok_but_decimal = """
"No problem.  Square root of {} is {}.  Now give me a challenge.  Something with
a decimal, and big."
"""

take_the_sq = input("\nWhat number does Bryant give you? ")
if take_the_sq.isdigit() is True or check_float(take_the_sq) is True:
    pass
else:
    print("Please only enter a whole number or a decimal - picking 5...")
    take_the_sq = 5
if "." not in str(take_the_sq) and int(take_the_sq) < 10:
    root = round(sqrt(int(take_the_sq)), 3)
    if len(str(root)) == 3:
        root = (str(root) + "00")
    print(too_easy.format(take_the_sq, root))
elif "." in str(take_the_sq) and float(take_the_sq) < 50:
    root = round(sqrt(float(take_the_sq)), 3)
    print(ok_but_bigger.format(take_the_sq, root))
elif "." not in str(take_the_sq) and int(take_the_sq) > 10:
    root = round(sqrt(int(take_the_sq)), 3)
    print(ok_but_decimal.format(take_the_sq, root))
else:
    root = round(sqrt(float(take_the_sq)), 3)
    print('\n"Sure, square root is {}.  Try another."\n'.format(root))

too_easy = """
"Too easy, Bryant.  Square root of {} is {}."
"""

ok_but_bigger = """
"Can't give me a real challange?  Square root of {} is {}... to 3 decimal
places."
"""

ok_but_decimal = """
"Square roots of decimaled numbers are more fun.  But square root of {} is {}."
"""

take_the_sq = input("What number does Bryant give you? ")
if take_the_sq.isdigit() is True or check_float(take_the_sq) is True:
    pass
else:
    print("Please only enter a whole number or a decimal - picking 5...")
    take_the_sq = 5
if "." not in str(take_the_sq) and int(take_the_sq) < 10:
    root = round(sqrt(int(take_the_sq)), 3)
    if len(str(root)) == 3:
        root = (str(root) + "00")
    print(too_easy.format(take_the_sq, root))
elif "." in str(take_the_sq) and float(take_the_sq) < 50:
    root = round(sqrt(float(take_the_sq)), 3)
    print(ok_but_bigger.format(take_the_sq, root))
elif "." not in str(take_the_sq) and int(take_the_sq) > 10:
    root = round(sqrt(int(take_the_sq)), 3)
    print(ok_but_decimal.format(take_the_sq, root))
else:
    root = round(sqrt(float(take_the_sq)), 3)
    print('\n"Square root of {} is {}... to 3 decimal places."\n'.format(
        take_the_sq, root))

# CONVERGENT STORY PATH CHAPTER 4
all_path_text3 = all_path_text3.strip('\n')
print(all_path_text3)

choice3 = str("\nIs the answer: (A) [Zebra] / (B) [Newspaper] / (C) "
              "[Dalmation]: ")
dec3 = test_ans((input(choice3)), choice3, 3)
print_response3(dec3, cons3a, cons3b, cons3c)

input("press any key to continue: ")

# CONVERGENT STORY PATH CHAPTER 5

all_path_text4 = all_path_text4.strip('\n')
print("\n", all_path_text4)

input("\npress any key to continue: \n")

outro_text = outro_text.strip('\n')
print(outro_text, "\n")
