# bh219, pg206

from easters import *
from literature import *

current_semester = 1
social = 0
work = 0
freak = 0

flunky = False
Gundelfine = False
Arduino = False


def fGA(num: int, f, G, A):
    global flunky, Gundelfine, Arduino

    if num == f:
        flunky = True
    elif num == G:
        Gundelfine = True
    elif num == A:
        Arduino = True


def fGA_require(f, G, A) -> int:

    if f is not None:
        return f
    elif G is not None:
        return G
    elif A is not None:
        return A
    else:
        return 0


def fGA_check(f, G, A):

    if f is not None:
        return flunky
    elif G is not None:
        return Gundelfine
    elif A is not None:
        return Arduino
    else:
        print("Something went wrong in fGA_check")
        return False


def identify(num: int, a1: str, a2: str, a3: str) -> str:

    if (num == 1):
        return a1
    elif (num == 2):
        return a2
    else:
        return a3


def identify_str(lit: str, a1: str, a2: str, a3: str) -> int:

    if (lit == a1):
        return 1
    elif (lit == a2):
        return 2
    else:
        return 3


def ask(question: str, punishment: int,
        answer1: str, answer2: str, answer3: str,
        f: int = None, f_req: int = None,
        G: int = None, G_req: int = None,
        A: int = None, A_req: int = None,
        end: int = 0, easter: int = 0,
        easter_num: int = 0) -> int:

    assert (1 <= punishment <= 3)

    result = input(question +
                   " [" + answer1 + " / " + answer2 + " / " + answer3 + "]: ")

    ans_num = identify_str(result, answer1, answer2, answer3)
    if ans_num == end:
        input("\nLebe glücklich!")
        input(">>>>>>>>>>>>> Game Over <<<<<<<<<<<<<")
        exit()

    if ans_num == easter:
        print(identify(easter_num, easter1, easter2, easter3))

    pun = identify(punishment, answer1, answer2, answer3)
    req = fGA_require(f_req, G_req, A_req)

    if req != 0 and result == identify(req, answer1, answer2, answer3) \
       and not fGA_check(f_req, G_req, A_req):
        input("\nHey hey, das hast du in der "
              "Vergangenheit nicht möglich gemacht!;) "
              "Zur Strafe wurde Pfad \"" + pun + "\" für dich ausgewählt.")
        return punishment

    if (result == answer1):
        fGA(1, f, G, A)
        return 1
    elif (result == answer2):
        fGA(2, f, G, A)
        return 2
    elif (result == answer3):
        fGA(3, f, G, A)
        return 3
    else:
        input("\nDu hast dich vertippt, du TEUPEL! "
              "Zur Strafe wurde Pfad \"" + pun + "\" für dich ausgewählt. "
              "Das hast du nun davon...")
        if punishment == end:
            input("\nLebe glücklich!")
            input(">>>>>>>>>>>>> Game Over <<<<<<<<<<<<<")
            exit()
        return punishment


def evaluate(social_id: int, work_id: int, ans: int) -> None:

    global social, work, freak

    if ans == social_id:
        social += 1
    elif ans == work_id:
        work += 1
    else:
        freak += 1


def semester(sem: int,
             soc_message: str, work_message: str, freak_message: str,
             exit_sem: bool = True):
    def ex():
        if exit_sem:
            input(">>>>>>>>>>>>> Game Over <<<<<<<<<<<<<")
            exit()
    if social >= sem * 1.7:
        input(soc_message)
        ex()
    elif work >= sem * 1.7:
        input(work_message)
        ex()
    elif freak >= sem * 1.7:
        input(freak_message)
    elif sem < 6:
        input("\nHerzlicher Glückwunsch!!!\n"
              "Du kannst dein Studium im " +
              str(sem + 1) + "-ten Semester fortsetzen!")


#############################################################################

if __name__ == "__main__":

    input(logo)
    input(start)
    # Semester 1
    evaluate(s_1_1, w_1_1, ask(q_1_1, 3, a_1_1_1, a_1_1_2, a_1_1_3, f=2))
    evaluate(s_1_2, w_1_2, ask(q_1_2, 1, a_1_2_1, a_1_2_2, a_1_2_3))
    semester(1, "\nGleich am Anfang nur Spaß haben bringt nichts...",
                "\nDu setzt dich zu sehr unter Druck, pass auf!",
                "\nCrazy one...", exit_sem=False)
    # Semester 2
    input("\nWillkommen im zweiten Semester!")
    evaluate(s_2_1, w_2_1, ask(q_2_1, 1, a_2_1_1, a_2_1_2, a_2_1_3, A=2, end=1))
    evaluate(s_2_2, w_2_2, ask(q_2_2, 2, a_2_2_1, a_2_2_2, a_2_2_3, f_req=3,
             easter=2, easter_num=1))
    semester(2, "\nAnschaulich hast du dich nur wegen "
                "der guten Gesellschaft beworben. "
                "Die Zetteln lösen sich aber nicht selbst...",

                "\nDu hast Augenringe und isst schon "
                "seit Wochen allein in der Kantine... "
                "Ohne Gesellschaft & Spaß macht das Studium wenig Sinn!",

                "\n[insert fun fact]", exit_sem=False)
    # Semester 3
    input("\nWillkommen im dritten Semester!")
    evaluate(s_3_1, w_3_1, ask(q_3_1, 2, a_3_1_1, a_3_1_2, a_3_1_3))
    evaluate(s_3_2, w_3_2, ask(q_3_2, 3, a_3_2_1, a_3_2_2, a_3_2_3))
    semester(3, leicht, krank,
             "\nLorem ipsum dolor sit amet, consectetur adipisici elit")
    # Semester 4
    input("\nWillkommen im vierten Semester!")
    evaluate(s_4_1, w_4_1, ask(q_4_1, 1, a_4_1_1, a_4_1_2, a_4_1_3, G=3))
    evaluate(s_4_2, w_4_2, ask(q_4_2, 3, a_4_2_1, a_4_2_2, a_4_2_3,
             easter=2, easter_num=2))
    semester(4, leicht, krank, "\nhttp://endless.horse/")
    # Semester 5
    input("\nWillkommen im fünften Semester!")
    evaluate(s_5_1, w_5_1, ask(q_5_1, 2, a_5_1_1, a_5_1_2, a_5_1_3))
    evaluate(s_5_2, w_5_2, ask(q_5_2, 2, a_5_2_1, a_5_2_2, a_5_2_3, A_req=3,
             easter=2, easter_num=3))
    semester(5, leicht, krank, "\n\"Papa, warum haben wir keinen Porsche?\"\n"
                               "...wenn der Grund nach dem Grund fragt...")
    # Semester 6
    input("\nWillkommen im letzten Semester!")
    evaluate(s_6_1, w_6_1, ask(q_6_1, 3, a_6_1_1, a_6_1_2, a_6_1_3, G_req=2))
    evaluate(s_6_2, w_6_2, ask(q_6_2, 1, a_6_2_1, a_6_2_2, a_6_2_3))
    semester(6, leicht, krank, "\nMensch, ich liebe dich.")

    input("\n===========================================\n"
          "Du hast durchgezogen! Wuhuu!!! Sehen wir, "
          "wie du mit den Punkten stehst! [Press ENTER]")
    input(">>> Punkte für sozial zu sein: " + str(social))
    input(">>> Punkte für fleißig zu sein: " + str(work))
    input(">>> Punkte für Verrücktheit: " + str(freak))
    input("\nDu könntest dein Balance finden, du hast fleißig gearbeitet, "
          "Freundschaften geknüpft, und riesig Spaß gemacht.\n"
          "(Außer wenn du unsinn angegeben hast lol)\n"
          "Viel Glück für die Zukunft!")
    input("\nFür den Stablisten-Effekt, spam den ENTER!")
    input(".")
    input("...")
    input(".....")
    input(".......")
    input(".........")
    input("...........")
    input(".............")
    input("...............")
    input(".................")
    input("Peter Grillessen")
    input(".................")
    input("...............")
    input(".............")
    input("...........")
    input(".........")
    input(".......")
    input("- und -")
    input(".......")
    input(".........")
    input("...........")
    input(".............")
    input("...............")
    input(".................")
    input("Benke Boldizsár Hargitai")
    input(".................")
    input("...............")
    input(".............")
    input("November 2021")
    input("...........")
    input(".........")
    input(".......")
    input(".....")
    input("...")
    input(".")
