# th236
from typing import Callable
from time import sleep
from interaction import (narrator_print, dialogue_print,
                         show_options, choose_option)


def next_action(first_option: str, second_option: str,
                first_sequence: Callable, second_sequence: Callable) -> None:

    show_options(first_option, second_option)
    choose_option(first_option, second_option,
                  first_sequence, second_sequence,
                  escape_sequence, invalid_sequence)
    sleep(1)


def invalid_sequence():

    narrator_print("Your brain tryed to execute an impossible task...")
    narrator_print("Everything around You dissolves into fragments...")
    dialogue_print("I just want to wake up from this nightmare!", "You")
    dialogue_print("Please just let me... wake up...", "You")
    narrator_print("You fall into an endless void and faint...")
    narrator_print("...")
    narrator_print("...")
    narrator_print("...")
    starting_sequence()


def escape_sequence():

    narrator_print("You open your eyes... You are laying in your bed")
    dialogue_print("So this was really just a dream, how crazy!?", "You")
    dialogue_print("But it's too early... maybe I should go back to sleep...",
                   "You")
    narrator_print("THE END")


def starting_sequence(memory: str = ""):

    narrator_print("You try to open your eyes... "
                   "your Head hurts{}.".format(memory))
    narrator_print("The bright cold light above You is dazzling...")
    narrator_print("You look around and everything around is white...")
    narrator_print("As You look down yourself, You realize you are fixated "
                   "on an operating table.")
    narrator_print("Far away You can hear steps...")
    next_action("call help", "search tool",
                call_help_sequence, search_tool_sequence)


def search_tool_sequence():

    narrator_print("You scan the room for anything that could be helpful.")
    narrator_print("While the whole room is clinically tidy, You find a "
                   "scalpel right next to your left hand.")
    dialogue_print("I must be dreaming, no one would be that stupid to "
                   "leave his scalpel here...", "You")
    narrator_print("You push away that thought and grab the knife.")
    next_action("cut free", "hide knife",
                cut_free_sequence, hide_knife_sequence)


def hide_knife_sequence():

    narrator_print("You hide the knife under your left palm.")
    narrator_print("Immediatly after this, a person in a white coat enters.")
    dialogue_print("Are You 'awake' already, hehe?", "The man")
    next_action("fake sleeping", "answer", play_dead_sequence, answer_sequence)


def answer_sequence():

    dialogue_print("Yes, I am awake", "You")
    curious_sequence()


def play_dead_sequence():

    narrator_print("You pretend You are still sleeping.")
    dialogue_print("Strange... I thought I heard something.", "The man")
    narrator_print("The man leaves the room")
    narrator_print("...")
    narrator_print("As the coast seems to be clear, You carefully "
                   "start freeing yourself.")
    narrator_print("Just after You finished, the man enters the room again.")
    dialogue_print("That should have been enough time...", "The man")
    dialogue_print("Let's go for the next round, hehe...", "The man")
    narrator_print("The man is preparing a syringe.")
    narrator_print("He get's really close to You.")
    next_action("fake sleep", "attack", sedation_sequence, attack_sequence)


def attack_sequence():

    narrator_print("Right before the syringe touches You, You grab his busy "
                   "arm with the syringe and pull him close.")
    narrator_print("He seems shocked and doesn't react at all.")
    narrator_print("You take your chance and slice the scalpell right through "
                   "his throat.")
    narrator_print("...")
    narrator_print("...")
    narrator_print("He doesn't bleed... You can't even see a wound..")
    dialogue_print("That is.. IMPOSSIBLE! The knife went directly through "
                   "your throat!", "You")
    dialogue_print("What kind of bullshit is this?!?", "You")
    narrator_print("The man looks at You and begins to smirk disgustingly")
    dialogue_print("Oh my... You can't win like that...", "The man")
    dialogue_print("Do You know the definition of insanity?", "The man")
    dialogue_print("Doing the same thing over and over again and expect "
                   "the outcome to change...", "The man")
    dialogue_print("Why would You do this?", "The man")
    dialogue_print("Oh right... You 'forgot', hehe", "The man")
    dialogue_print("Well let me give You a hint:", "The man")
    dialogue_print("If You want to get out of here, You have to think "
                   "outside of the box.", "The man")
    dialogue_print("Something that isn't expected from You!", "The man")
    next_action("what?", "understood",
                not_understood_sequence, not_understood_at_all_sequence)


def not_understood_sequence():

    dialogue_print("I don't understand...", "You")
    dialogue_print("Oh You will. Just pay attention to the signs.", "The man")
    dialogue_print("And now You can go back to 'sleep'.", "The man")
    dialogue_print("See You when You 'wake up', hehe", "The man")
    sedation_sequence()


def not_understood_at_all_sequence():

    dialogue_print("Ah, I think I get it now.", "You")
    dialogue_print("Oh I don't think so.", "The man")
    dialogue_print("Maybe next time, good 'sleep'.", "The man")
    sedation_sequence()


def cut_free_sequence():

    narrator_print("You immediatly try to cut through the fixation.")
    dialogue_print("HEY! Are You nuts?!?", "A voice")
    narrator_print("A man in a white coat is entering the room and taking "
                   "away the knife before You can do anything.")
    dialogue_print("You are naughty today, aren't You? hehe...", "The man")
    dialogue_print("Let's put You to 'sleep' again", "the man")
    narrator_print("You can't get over the impression, "
                   "that You are trapped in an endless nightmare.")
    dialogue_print("Please let me 'wake up'... please..", "You")
    sedation_sequence()


def call_help_sequence():

    dialogue_print("Hello? Can someone hear me?", "You")
    dialogue_print("I need help!", "You")
    narrator_print("...")
    narrator_print("The steps are getting louder, someone is coming.")
    narrator_print("...")
    narrator_print("A man in a white coat enters the room.")
    dialogue_print("Hello, I see You are 'awake', how do You feel?", "The man")
    next_action("okay", "what happened?",
                cooperation_sequence, curious_sequence)


def cooperation_sequence():

    dialogue_print("I am feeling okay...", "You")
    dialogue_print("Oh wonderful! That means the side effects aren't "
                   "killing You...  yet.", "The man")
    dialogue_print("Let's go for another round and "
                   "put You to 'sleep' hehehehe...'", "The man")
    narrator_print("You try to break free but the fixation is too tight.")
    sedation_sequence()


def curious_sequence():

    dialogue_print("What the hell happened here? Why am I tied up?", "You")
    dialogue_print("Oh we are curiuos today? hehe", "The man")
    dialogue_print("But let me explain.. again..", "The man")
    dialogue_print("We got You here to test our new medicine.", "The man")
    dialogue_print("An amnesia inducer, unfortunately, we aren't allowed "
                   "to test it yet officially...", "The man")
    dialogue_print("But luckily we got You!", "The man")
    dialogue_print("You wouldn't believe how often we've held this "
                   "conversation!", "The man")
    dialogue_print("And since You are still able to speak... and breathe..."
                   " we will just go for another round.", "The man")
    dialogue_print("I am curious about when you will 'wake up' this time.",
                   "The man")
    sedation_sequence()


def sedation_sequence():

    narrator_print("He is injecting a substance into You.")
    narrator_print("The medicine is flooding your veins.")
    narrator_print("A sound of crashing waves get's unbearably loud.")
    narrator_print("You pass out...")
    narrator_print("...")
    narrator_print("...")
    narrator_print("...")
    starting_sequence()


if __name__ == "__main__":

    starting_sequence()
