# th236
from typing import Callable  # type annotations for sequence functions
from time import sleep


def narrator_print(phrase: str) -> None:

    """Making a difference between the story and the
    text based 'User Interface'. """

    print(phrase)
    sleep(0.5)


def dialogue_print(phrase: str, speaker: str):

    print("{}: '{}'".format(speaker, phrase))
    sleep(0.5)


def show_options(first_option: str, second_option: str) -> None:

    print("What will You do? ", end="")
    print("[ {} | {} ] : ".format(first_option, second_option), end="")


def choose_option(first_option: str, second_option: str,
                  first_sequence: Callable, second_sequence: Callable,
                  escape_sequence: Callable, invalid_sequence: Callable):

    choice = input().lower()
    if choice == first_option:
        first_sequence()
    elif choice == second_option:
        second_sequence()
    elif choice == "wake up":
        escape_sequence()
    else:
        invalid_sequence()
